#ifndef MT_COLLISION_H
#define MT_COLLISION_H

#include <iostream>
#include <vector>

#include "mtTypes.h"
#include "mtNucleon.h"
#include "mtCollisionHeader.h"

class mtCollision
{
private:
  mtCollisionHeader fCollisionHeader;
  std::vector<mtNucleon> fInitialNucl;
  std::vector<mtNucleon> fFinalNucl;
public:
  mtCollision();
  virtual ~mtCollision();

  virtual void Clear();

  // Setters
  virtual void SetCollisionHeader(mtCollisionHeader *const& _coll);
  virtual void AddInitialNucleon(mtNucleon *const& _nucl) { fInitialNucl.emplace_back(*_nucl); }
  virtual void AddFinalNucleon(mtNucleon *const& _nucl) { fFinalNucl.emplace_back(*_nucl); }

  // Getters
  mtCollisionHeader *GetCollisionHeader() { return &fCollisionHeader; }
  mtNucleon         *GetInitialNucleon(mtInt _id) { return &fInitialNucl.at(_id); }
  mtNucleon         *GetFinalNucleon(mtInt _id) { return &fFinalNucl.at(_id); }

  ClassDef(mtCollision,1);
};

#endif