#ifndef MT_EVENT_H
#define MT_EVENT_H

#include <iostream>
#include <vector>

#include "mtTypes.h"
#include "mtCollision.h"
#include "mtCollisionHeader.h"
#include "mtNucleon.h"
#include "mtEventHeader.h"
#include "mtParticle.h"

class mtEvent : public TObject
{
private:
  mtEventHeader            fEventHeader;
  mtInt                    fNumColls;
  mtInt                    fNumParticles;
  std::vector<mtCollision> fCollisions;
  std::vector<mtParticle>  fParticles;
public:
  mtEvent();
  virtual ~mtEvent();

  virtual void Clear();

  // Setters
  virtual void SetEventHeader(mtEventHeader *const& _header);
  virtual void AddCollision(mtCollision *const& _coll) { fCollisions.emplace_back(*_coll); fNumColls = fCollisions.size(); }
  virtual void AddParticle(mtParticle *const& _part) { fParticles.emplace_back(*_part); fNumParticles = fParticles.size(); }

  // Getters
  mtEventHeader *GetEventHeader() { return &fEventHeader; }
  mtCollision   *GetCollision(mtInt _id) { return &fCollisions.at(_id); }
  mtParticle    *GetParticle(mtInt _id) { return &fParticles.at(_id); }
  mtInt          GetNcoll()      const { return fNumColls; }
  mtInt          GetNparticles() const { return fNumParticles; }

  ClassDef(mtEvent,1);
};

#endif