#ifndef MT_PARTICLE_H
#define MT_PARTICLE_H

#include <iostream>
#include <vector>

#include <Rtypes.h>
#include <TObject.h>

#include "mtTypes.h"

class mtParticle
{
private:
  mtInt     fId;
  mtInt     fPdg;
  mtDouble  fE;
  mtDouble  fPx;
  mtDouble  fPy;
  mtDouble  fPz;
  mtDouble  fM;
  mtDouble  fRt;
  mtDouble  fRx;
  mtDouble  fRy;
  mtDouble  fRz;
public:
  mtParticle();
  virtual ~mtParticle();

  // Setters
  virtual void SetId(mtInt _a)    { fId = _a; }
  virtual void SetPdg(mtInt _a)   { fPdg = _a; }
  virtual void SetE(mtDouble _a)  { fE = _a; }
  virtual void SetPx(mtDouble _a) { fPx = _a; }
  virtual void SetPy(mtDouble _a) { fPy = _a; }
  virtual void SetPz(mtDouble _a) { fPz = _a; }
  virtual void SetM(mtDouble _a)  { fM = _a; }
  virtual void SetT(mtDouble _a)  { fRt = _a; }
  virtual void SetX(mtDouble _a)  { fRx = _a; }
  virtual void SetY(mtDouble _a)  { fRy = _a; }
  virtual void SetZ(mtDouble _a)  { fRz = _a; }

  // Getters
  mtInt    GetId()  const { return fId; }
  mtInt    GetPdg() const { return fPdg; }
  mtDouble GetE()   const { return fE; }
  mtDouble GetM()   const { return fM; }
  mtDouble GetPx()  const { return fPx; }
  mtDouble GetPy()  const { return fPy; }
  mtDouble GetPz()  const { return fPz; }
  mtDouble GetT()   const { return fRt; }
  mtDouble GetX()   const { return fRx; }
  mtDouble GetY()   const { return fRy; }
  mtDouble GetZ()   const { return fRz; }

  ClassDef(mtParticle,1);
};

#endif